#!/bin/bash
set -e
export PGPASSWORD=$POSTGRES_PASSWORD;
psql -v ON_ERROR_STOP=1 --username "$POSTGRES_USER" --dbname "$POSTGRES_DB" <<-EOSQL
  CREATE USER $WAREHOUSE_DB_USER WITH PASSWORD '$WAREHOUSE_DB_PASS';
  CREATE DATABASE $WAREHOUSE_DB;
  GRANT ALL PRIVILEGES ON DATABASE $WAREHOUSE_DB TO $WAREHOUSE_DB_USER;
  GRANT ALL PRIVILEGES ON DATABASE $WAREHOUSE_DB TO $POSTGRES_USER;
  \connect $WAREHOUSE_DB $WAREHOUSE_DB_USER
  BEGIN;
    CREATE TABLE IF NOT EXISTS product (
	    id serial PRIMARY KEY,
	    name VARCHAR(200) UNIQUE NOT NULL,
	    price numeric CONSTRAINT positive_price CHECK (price >= 0) NOT NULL,
	    articles JSONB NOT NULL
	  );
	  CREATE INDEX IF NOT EXISTS idx_product_name ON product (name);

    CREATE TABLE IF NOT EXISTS article (
	    id serial PRIMARY KEY,
        article_id INT UNIQUE NOT NULL,
	    name VARCHAR(200) NOT NULL,
	    stock INT CONSTRAINT positive_stock CHECK (stock >= 0) NOT NULL
	  );
	  CREATE INDEX IF NOT EXISTS idx_article_id ON article (article_id);

  COMMIT;
EOSQL
